/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

// interpolowany wektor kierunku rda wiata

varying vec3 L;

// uchwyt tekstury podstawowej

uniform sampler2D rgb_map;

// uchwyt tekstury z map wektorw normalnych

uniform sampler2D normal_map;

void main ()
{
    // pobranie skadowych RGB teksela tekstury podstawowej
    vec3 rgb = texture2D (rgb_map,gl_TexCoord[0]).rgb;

    // pobranie wsprzdnych [X,Y,Z] wektora normalnego
    vec3 normal = texture2D (normal_map,gl_TexCoord[0]).xyz;

    // normalizacja i przesunicie wartoci skadowych wektora normalnego
    normal = (normal - 0.5) * 2;

    // normalizacja wektora kierunku rda wiata
    L = normalize (L);

    // zwichrowanie wektora normalnego
    vec3 NdotL = dot (normal,L);

    // obliczenie skadowych koloru wynikowego fragmentu
    gl_FragColor.xyz = rgb * NdotL;
}