/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

// znormalizowany wektor normalny we wsprzdnych obserwatora

varying vec3 N;

// znormalizowany wektor powkowy

varying vec3 H;

// skadowe wiata rozproszonego, otaczajcego 
// i odbitego (bez wykadnika rozbysku)

varying vec4 diffuse,ambient,specular;

// wykadnik rozbysku wiata

varying float shininess;

void main ()
{
    // przeksztacenie wektora normalnego gl_Normal do wsprzdnych ukadu obserwatora
    // przy uyciu macierzy gl_NormalMatrix); jest to standardowe przeksztacenie
    // klasycznego potoku OpenGL; otrzymany rezultat jest normalizowany
    N = normalize (gl_NormalMatrix * gl_Normal);

    // normalizacja wektora powkowego
    H = normalize (gl_LightSource[0].halfVector.xyz);

    // obliczenie skadowych wiata rozproszonego
    diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;

    // obliczenie skadowych wiata otaczajcego
    ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient +
              gl_LightModel.ambient * gl_FrontMaterial.ambient;
    
    // obliczenie wiata odbitego (bez wykadnika rozbysku)
    specular = gl_FrontMaterial.specular * gl_LightSource[0].specular;

    // obliczenie wykadnika rozbysku wiata
    shininess = gl_FrontMaterial.shininess;

    // standardowe przeksztacenie wierzchokw
    gl_Position = ftransform ();
}
