/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

void main ()
{
    // przeksztacenie wektora normalnego gl_Normal do wsprzdnych ukadu obserwatora
    // przy uyciu macierzy gl_NormalMatrix); jest to standardowe przeksztacenie
    // klasycznego potoku OpenGL; otrzymany rezultat jest normalizowany
    vec3 N = normalize (gl_NormalMatrix * gl_Normal);

    // normalizacja wektora kierunku wiata; zakadamy, e mamy wiato
    // kierunkowe, std gl_LightSource[0].position zawiera wektor kierunku wiata
    vec3 L = normalize (vec3 (gl_LightSource[0].position));

    // obliczenie cosinusa kta pomidzy wektorem normalnym a wektorem
    // kierunku wiata; poniewa oba wektory s jednostkowe ich iloczyn
    // skalarny jest rwny poszukiwanemu cosinusowi
    float NdotL = max (dot (N,L),0.0);

    // obliczenie wartoci skadowych koloru wierzchoka
    gl_FrontColor = NdotL * gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;

    // standardowe przeksztacenie wierzchokw
    gl_Position = ftransform ();
}
